package com.ynet.life.search.core;

import java.util.Arrays;
import org.apache.lucene.search.BooleanClause.Occur;

public class QueryStringParser {

   private static final String QUERY_SEPERATOR = " ";
   private static final String FIELD_SEPERATOR = ":";
   private static final String MUST = "+";
   private static final String MUST_NOT = "-";
   private String[] fields;
   private String[] queries;
   private Occur[] occurs;


   public void parse(String occur) {
      String[] var8 = occur.split(" ");
      int k = 0;
      String[] fieldBuf = new String[var8.length];
      String[] queryBuf = new String[var8.length];

      int i;
      for(i = 0; i < var8.length; ++i) {
         int query;
         if((query = var8[i].indexOf(":")) != -1) {
            String field = var8[i].substring(0, query);
            String var9 = var8[i].substring(query + 1, var8[i].length());
            if(field != null && var9 != null) {
               field = field.trim();
               var9 = var9.trim();
               if(field.length() != 0 && var9.length() != 0 && (field.length() != 1 || !"+".equals(field) && !"-".equals(field))) {
                  fieldBuf[k] = field;
                  queryBuf[k] = var9;
                  ++k;
               }
            }
         }
      }

      this.fields = new String[k];
      this.queries = new String[k];
      this.occurs = new Occur[k];

      for(i = 0; i < k; ++i) {
         occur = fieldBuf[i].substring(0, 1);
         if("+".equals(occur)) {
            this.fields[i] = fieldBuf[i].substring(1);
            this.occurs[i] = Occur.MUST;
         } else if("-".equals(occur)) {
            this.fields[i] = fieldBuf[i].substring(1);
            this.occurs[i] = Occur.MUST_NOT;
         } else {
            this.fields[i] = fieldBuf[i];
            this.occurs[i] = Occur.SHOULD;
         }

         this.queries[i] = queryBuf[i];
      }

   }

   public String[] getFields() {
      return this.fields;
   }

   public String[] getQueries() {
      return this.queries;
   }

   public Occur[] getOccurs() {
      return this.occurs;
   }

   public static void main(String[] queryString) {
      String queryString1 = "-bankType:314 cityCode:3052 +provinceCode:320 +fullContents:农村商业银行";
      QueryStringParser parser;
      (parser = new QueryStringParser()).parse(queryString1);
      System.out.println("Fields: " + Arrays.toString(parser.getFields()));
      System.out.println("Queries: " + Arrays.toString(parser.getQueries()));
      System.out.println("Occurs: " + Arrays.toString(parser.getOccurs()));
   }
}
